;**********************************************************************
; PIC Program for CMU-800 MIDI Kit  Program RJB 		Jan-Apr.2004
; DEVICE : PIC16F876
; CLOCK  : 10MHz
;
; C
; Apr.17 2004 SYNCOUTHɂC.
;**********************************************************************
		list		p=16F876
		#include	<p16F876.inc>

;***********************************************************************
; RtBO[VWX^
;***********************************************************************
		__CONFIG	_CP_OFF & _WDT_OFF & _LVP_OFF & _PWRTE_ON & _HS_OSC

;***********************************************************************
; ϐ`
;***********************************************************************
WTEMP		EQU		20H	; WWX^Ҕ
STATUSTEMP	EQU		21H	; STATUSWX^Ҕ
FSRTEMP		EQU		22H	; FSRWX^Ҕ
PCLATHTEMP	EQU		23H	; PCLATHWX^Ҕ

TEMP1		EQU		24H	; ėpe|
COUNT0		EQU		25H	; fBCpJE^0
COUNT1		EQU		26H	; fBCpJE^1

CNT8253		EQU		27H	; 8253JE^[ZN^	
LSB8253		EQU		28H	; 8253JE^[LSB
MSB8253		EQU		29H	;@8253JE^[MSB

RCVDAT		EQU		30H	; MIDIf[^
MIDI_FLG	EQU		31H	; MIDItO
MIDI_NOTE	EQU		32H	; MIDIm[g
TONE_NO		EQU		33H	; g[ԍ0-99
RHYTHM_FLG	EQU		34H ; YtO
RHYTHM_CTL	EQU		35H ; Y

SYNC_COUNT	EQU		40H ; MIDI Sync clock Count
SYNC_COUNT2	EQU		41H ; SYNC_COUNT / 2
START_STOP	EQU		42H	; SATRT / STOP tO

;***********************************************************************
; ZbgxN^
;***********************************************************************
        LIST
		ORG		00H				; ZbgxN^OԒn
		GOTO	INIT			; PIC[`

;***********************************************************************
; 荞݃xN^
;***********************************************************************
		ORG		04H				; 荞݃xN^͂SԒn
		GOTO	INTR			; 荞ݏ[`

;***********************************************************************
; 荞ݏ
;***********************************************************************
INTR
		MOVWF	WTEMP			; ReLXgۑ
		SWAPF	STATUS,W
		CLRF	STATUS
		MOVWF	STATUSTEMP
		MOVF	PCLATH,W
		MOVWF	PCLATHTEMP
		CLRF	PCLATH
		MOVF	FSR,W
		MOVWF	FSRTEMP

		BCF		INTCON,T0IF		; ^C}O荞݃tONA
		MOVLW	0F5H			; ^C}[0@JEgl 255-10=245 C^[o1ms
		MOVWF	TMR0			; TMR0ɃZbg

		; DIN SYNC
		DECF	SYNC_COUNT2,F	; SYNC_COUNT2-1
		BTFSC	STATUS,Z		; SYNC_COUNT20Ȃ
		BSF		PORTA,0			; TEMPO_CLK OFF
		INCF	SYNC_COUNT,F	; SYNC_COUNT+1

		; RHYTHM
		COMF	RHYTHM_CTL,W	; ݂̃Y
		ADDWF	RHYTHM_FLG,W	; YtOPĂȂ
		BTFSC	STATUS,Z
		GOTO	POP		

		CALL	SA8255PB		; 8255|[gB
		COMF	RHYTHM_FLG,W	; YtO]
		MOVWF	RHYTHM_CTL
		MOVWF	PORTB
		CALL	WR_PULSE		; 8255
		CLRF	RHYTHM_FLG		; YtONA

POP
		CLRF	STATUS			; ReLXgA
		MOVF	FSRTEMP,W
		MOVWF	FSR
		MOVF	PCLATHTEMP,W
		MOVWF	PCLATH
		SWAPF   STATUSTEMP,W
		MOVWF	STATUS
		SWAPF   WTEMP,F
		SWAPF   WTEMP,W
		RETFIE


;***********************************************************************
; PIC
;***********************************************************************
INIT	
		BSF		STATUS,RP0		; [oNPɃZbg
		BCF		STATUS,RP1		;
		MOVLW	06H				; WWX^06HZbg
		MOVWF	ADCON1			; ADCON106HZbg PORTASăfW^
		CLRF	TRISA			; TRISANA RAo͂ɃZbg
		CLRF	TRISB			; TRISBNA RBo͂ɃZbg
		MOVLW	080H			; WWX^80HZbg
		MOVWF	TRISC			; TRISC80HZbg
								; RC<6:0>o
								; RC<7>
		MOVLW	087H			; WWX^87HZbg
		MOVWF	OPTION_REG		; OPTION_REG80HZbg
								; PBPU=1	vAbvRgpȂ 
								; INTEDG=0	RB0/INTs̗Ŋ荞 
								; T0CS=0	NbNgp
								; T0SE=0	RA4/T0CKIs̗オŃJEgAbv 
								; PSA=0		vXP[TMR0^C}[Ɏgp 
								; PS2 PS1 PS0 = 1 1 1	vXP[l256

		CLRF	TXSTA			; USART TX mode Disable
		MOVLW	004H			; USART Baud Rate 31.25kbps
		MOVWF	SPBRG			; BRGɃZbg

		BCF		STATUS,RP0		; [oNOɃZbg
		MOVLW	090H			; USART Async mode
		MOVWF	RCSTA			; USART RX mode
		MOVLW	0F5H			; ^C}[0@JEgl 255-10=245 C^[o1ms
		MOVWF	TMR0			; TMR0ɃZbg

		BSF		INTCON,T0IE		; ^C}0荞݋
		BSF		INTCON,GIE		; O[o荞݋

;***********************************************************************
; C
;***********************************************************************
MAIN	
		;e|[glZbg
		MOVLW	00FH			; WWX^0FHZbg
		MOVWF	PORTA			;
		MOVLW	000H			; WWX^00HZbg
		MOVWF	PORTB			;
		MOVLW	0F0H			; WWX^F0HZbg
		MOVWF	PORTC			;

;***********************************************************************
; ϐ
;***********************************************************************
		CLRF	MIDI_FLG
		CLRF	RHYTHM_FLG
		CLRF	START_STOP

;***********************************************************************
; EGCg
;***********************************************************************
		CALL	DL5MS
		CALL	DL5MS
		CALL	DL5MS
		CALL	DL5MS
		CALL	DL5MS

;***********************************************************************
; 8255CjVCY
;  A3=1 A2=0 Select 8255
;  A1  A0
;   0   0  port A
;   0   1  port B
;   1   0  port C
;   1   1  Control
;***********************************************************************
;8255 Control
		CALL	SA8255CTRL		; Set Address 8255 Control
		MOVLW	088H			; 8255 PortA Mode0 OUT
								; 8255 PortB Mode0 OUT
								; 8255 PortC IN OUT
		MOVWF	PORTB
		CALL	WR_PULSE

;8255 PortA Init
		CALL	SA8255PA		; Set Adress 8255 Port A
		MOVLW	0BFH			; WWX^FFHZbg
		MOVWF	PORTB
		CALL	WR_PULSE

;8255 PortB Init
		CALL	SA8255PB		; Set Adress 8255 Port B
		MOVLW	0FFH			; WWX^FFHZbg
		MOVWF	RHYTHM_CTL
		MOVWF	PORTB
		CALL	WR_PULSE

;8255 PortC Init
		CALL	SA8255PC		; Set Adress 8255 Port C
		MOVLW	0FFH			; WWX^FFHZbg
		MOVWF	PORTB
		CALL	WR_PULSE

;***********************************************************************
; 8253CjVCY
;  A3=0 A2=0 Select 8253#1
;  A3=0 A2=1 Select 8253#2
;   A1  A0
;   0   0  Couner A
;   0   1  Couner B
;   1   0  Couner C
;   1   1  Control
;***********************************************************************
;8253#1 Control
		MOVLW	0D3H			; RC7=1 RC6=1 IOREQ=0 WR=1
								; A3=0 A2=0	Adress 8253#1
								; A1=1 A0=1	8253 Control							
		MOVWF	PORTC			;
		MOVLW	036H			; 8253 CounterA Mode3
		MOVWF	PORTB
		CALL	WR_PULSE
		MOVLW	076H			; 8253 CounterB Mode3
		MOVWF	PORTB
		CALL	WR_PULSE
		MOVLW	0B6H			; 8253 CounterC Mode3
		MOVWF	PORTB
		CALL	WR_PULSE

;8253#2 Control
		MOVLW	0D7H			; RC7=1 RC6=1 IOREQ=0 WR=1
								; A3=0 A2=1	Adress 8253#2
								; A1=1 A0=1	8253 Control							
		MOVWF	PORTC			;
		MOVLW	036H			; 8253 CounterA Mode3
		MOVWF	PORTB
		CALL	WR_PULSE
		MOVLW	076H			; 8253 CounterB Mode3
		MOVWF	PORTB
		CALL	WR_PULSE
		MOVLW	0B6H			; 8253 CounterC Mode3
		MOVWF	PORTB
		CALL	WR_PULSE

;***********************************************************************
; C[v
;***********************************************************************
MAINLOOP	
		BTFSS	PIR1,RCIF		; MIDIMH
		GOTO	MAINLOOP		; xMAINLOOPɃWv

		BTFSC	RCSTA,FERR		; t[~OG[H
		GOTO	FRMERR
		BTFSC	RCSTA,OERR		;@I[o[G[H
		GOTO	OVRRUN

		BSF		PORTA,3			; G[\NA

		MOVF	RCREG,W			; PoCgM
		MOVWF	RCVDAT			; MIDIf[^PoCgRCVDATɕۑ

		BTFSS	RCVDAT,7		; Xe[^XoCgH
		GOTO	DATABYTE		; lhchf[^oCg
	
		MOVF	RCVDAT,W		; RCVDAT烍[h
		ANDLW	00FH			; ʂSrbg
		MOVWF	MIDI_FLG		; lhch`lۑ		

		MOVF	RCVDAT,W		; m[gItbZ[WH
		ANDLW	0F0H
		SUBLW	080H
		BTFSC	STATUS,Z
		GOTO	MSGNOTEOFF
		
		MOVF	RCVDAT,W		; m[gIbZ[WH
		ANDLW	0F0H
		SUBLW	090H
		BTFSC	STATUS,Z
		GOTO	MSGNOTEON

		MOVF	RCVDAT,W		; ^C~ONbNbZ[WH
		SUBLW	0F8H
		BTFSC	STATUS,Z
		GOTO	MSGTIMECLOCK

		MOVF	RCVDAT,W		; X^[gbZ[WH
		SUBLW	0FAH
		BTFSC	STATUS,Z
		GOTO	MSGSTART

		MOVF	RCVDAT,W		; ReBj[bZ[WH
		SUBLW	0FBH
		BTFSC	STATUS,Z
		GOTO	MSGSTART

		MOVF	RCVDAT,W		; XgbvbZ[WH
		SUBLW	0FCH
		BTFSC	STATUS,Z
		GOTO	MSGSTOP

		CLRF	MIDI_FLG		; ȊÕbZ[W̓tOZbg
		GOTO	MAINLOOP		; C[vɖ߂

;@m[gItbZ[W
MSGNOTEOFF
		BSF		MIDI_FLG,7		; m[gbZ[WtOZbg 
		BCF		MIDI_FLG,6		; m[gIbZ[WtONA 
		BCF		MIDI_FLG,4		; m[gItONA 
		GOTO	MAINLOOP		; C[vɖ߂

;@m[gIbZ[W
MSGNOTEON
		BSF		MIDI_FLG,7		; m[gbZ[WtOZbg 
		BSF		MIDI_FLG,6		; m[gIbZ[WtOZbg 
		BSF		MIDI_FLG,4		; m[gItOZbg 
		GOTO	MAINLOOP		; C[vɖ߂

; ^C~ONbNbZ[W
MSGTIMECLOCK		
		BCF		STATUS,C		; L[tONA
		RRF		SYNC_COUNT,W	; EɃVtg SYNC_COUNT / 2
		MOVWF	SYNC_COUNT2		; SYNC_COUNT2ɕۑ
		CLRF	SYNC_COUNT		; SYNC_COUNTNA		
		BCF		PORTA,0			; TEMPO_CLK ON
		BTFSC	START_STOP,7
		BCF		PORTA,1
		BTFSC	START_STOP,6
		BSF		PORTA,1
		CLRF	START_STOP
		GOTO	MAINLOOP

; X^[gbZ[W^ReBj[bZ[W
MSGSTART
		BSF		START_STOP,7
		GOTO	MAINLOOP		
		
; XgbvbZ[W
MSGSTOP
		BSF		START_STOP,6
		GOTO	MAINLOOP		

; f[^oCg
DATABYTE
		MOVF	MIDI_FLG,W
		ANDLW	080H			; m[gbZ[WȊO͖
		BTFSC	STATUS,Z
		GOTO	MAINLOOP
		BTFSC	MIDI_FLG,5		; m[gio[MρH
		GOTO	VELDATA
		MOVF	RCVDAT,W
		MOVWF	MIDI_NOTE		; m[gio[ۑ
		BSF		MIDI_FLG,5		; m[gio[Mς݃tOZbg		
		GOTO	MAINLOOP		; C[vɖ߂

;׃VeBf[^
VELDATA
		MOVF	RCVDAT,W		; xVeBȌꍇ
		BTFSC	STATUS,Z
		BCF		MIDI_FLG,4		; m[gItONA 

		BTFSC	MIDI_FLG,4		; 		
		BCF		PORTA,2			; m[gILED_
		BTFSS	MIDI_FLG,4		; 		
		BSF		PORTA,2			; m[gILED

		MOVF	MIDI_FLG,W		; Y`lH
		ANDLW	00FH			; ʂSrbg
		SUBLW	009H			; MIDI 10CH
		BTFSC	STATUS,Z
		GOTO	CTL_RHYTHM		; Y

		MOVF	MIDI_FLG,W		; 1-8`lH
		ANDLW	00FH			; ʂSrbg
		SUBLW	007H			; MIDI 8CH菬H
		BTFSC	STATUS,C
		GOTO	CTL_CVGATE		; CVGATE		

		GOTO	MAINLOOP		; C[vɖ߂

;***********************************************************************
; USART G[
;***********************************************************************
; t[~OG[
FRMERR
		MOVF	RCREG,W			; _~[f[^ƂĎM
		BCF		PORTA,3			; G[kdc\
		GOTO	MAINLOOP		; C[vɖ߂

; I[o[G[
OVRRUN
		BCF		RCSTA,CREN		; I[o[G[
		BSF		RCSTA,CREN
		BCF		PORTA,3			; G[kdc\
		GOTO	MAINLOOP		; C[vɖ߂

;***********************************************************************
; CVGATE
;***********************************************************************
CTL_CVGATE
		MOVLW	D'24'			; Œቹ̓m[gio[24
		SUBWF	MIDI_NOTE,W		; MIDINOTE - 24
		BTFSS	STATUS,C		; 24菬H
		MOVLW	000H			; 0ɂ
		ANDLW	03FH			; ʂUrbg
		MOVWF	TEMP1			; CVGATEf[^ɕۑ		

		BTFSS	MIDI_FLG,4		; m[gIH 
		BSF		TEMP1,7			; GATE ON
		BCF		TEMP1,6			; TUNEGATEOFF
		CALL	SA8255PA		; Set Adress 8255 Port A
		MOVF	TEMP1,W			; CVGATEf[^Zbg
		MOVWF	PORTB
		CALL	WR_PULSE		; 

		CALL	TONE

		MOVF	MIDI_FLG,W		; MIDI`l[h
		ANDLW	007H			; ʂSrbg
		MOVWF	TEMP1	
		BCF		STATUS,C		; L[tONA
		RLF		TEMP1,F			; ɃVtg
		BSF		TEMP1,0			; `lZNgCH DZbg
		CALL	SA8255PC		; Set Adress 8255 Port C
		MOVF	TEMP1,W			; `lZNg񃍁[h
		MOVWF	PORTB
		CALL	WR_PULSE		; 
		CALL	DL50US

		BCF		TEMP1,0			; `lZNgCH DNA
		CALL	SA8255PC		; Set Adress 8255 Port C
		MOVF	TEMP1,W			; `lZNg񃍁[h
		MOVWF	PORTB
		CALL	WR_PULSE		; 
		CALL	DL50US

		BSF		TEMP1,0			; `lZNgCH DZbg
		CALL	SA8255PC		; Set Adress 8255 Port C
		MOVF	TEMP1,W			; `lZNg񃍁[h
		MOVWF	PORTB
		CALL	WR_PULSE		; 

		GOTO	MAINLOOP

;***********************************************************************
; Y
;***********************************************************************
CTL_RHYTHM
		BTFSS	MIDI_FLG,4		; m[gIH 
		GOTO	MAINLOOP

		MOVF	MIDI_NOTE,W		; BD
		SUBLW	D'36'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,7

		MOVF	MIDI_NOTE,W		; SD
		SUBLW	D'38'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,6

		MOVF	MIDI_NOTE,W		; LT
		SUBLW	D'45'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,5

		MOVF	MIDI_NOTE,W		; MT
		SUBLW	D'48'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,4

		MOVF	MIDI_NOTE,W		; CY
		SUBLW	D'49'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,3

		MOVF	MIDI_NOTE,W		; OH
		SUBLW	D'46'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,2

		MOVF	MIDI_NOTE,W		; CH
		SUBLW	D'42'
		BTFSC	STATUS,Z
		BSF		RHYTHM_FLG,1

		GOTO	MAINLOOP		; C[vɖ߂

;***********************************************************************
; TONE
;***********************************************************************
TONE
		MOVF	MIDI_FLG,W		; MIDI`l[h
		ANDLW	007H			; ʂSrbg
		SUBLW	005H			; CH6傫
		BTFSS	STATUS,C
		RETURN

		MOVF	MIDI_FLG,W		; MIDI`l[h
		ANDLW	007H			; ʂSrbg
		ADDLW	0D0H
		MOVWF	CNT8253			; 8253JE^ZN^ɕۑ		

		MOVF	MIDI_FLG,W		; MIDI`l[h
		ANDLW	007H			; 3rbg
		SUBLW	002H			; CH3傫
		BTFSS	STATUS,C
		INCFSZ	CNT8253,F		; 8253JE^ZN^+1

		MOVLW	D'16'			; Œቹ̓m[gio[16
		SUBWF	MIDI_NOTE,W
		BTFSS	STATUS,C		; 16菬H
		MOVLW	000H			; 0ɂ
		MOVWF	TONE_NO			; g[ԍۑ

		CALL	EEPROMREAD
		MOVWF	MSB8253			

		MOVLW	064H			; EEPROMAhX+100
		ADDWF	TONE_NO,W
		CALL	EEPROMREAD
		MOVWF	LSB8253

		MOVF	CNT8253,W		; 8253JE^ZNg
		MOVWF	PORTC			;
		MOVF	LSB8253,W		; 8253 Counter LSB
		MOVWF	PORTB
		CALL	WR_PULSE
		MOVF	MSB8253,W		; 8253 Counter MSB
		MOVWF	PORTB
		CALL	WR_PULSE
		RETURN

;***********************************************************************
; ddoqnl̓ǂݏo
;***********************************************************************
EEPROMREAD
		BCF		STATUS,RP0		; BANK2
		BSF		STATUS,RP1		;
		MOVWF	EEADR			; EEPROM DATA Address
		BSF		STATUS,RP0		; BANK3
		BSF		STATUS,RP1		;
		BCF		EECON1,EEPGD	; f[^ANZX
		BSF		EECON1,RD		; ǂݏo
		BCF		STATUS,RP0		; BANK2
		BSF		STATUS,RP1		;
 		MOVF	EEDATA,0		; 
		BCF		STATUS,RP0		; BANK0
		BCF		STATUS,RP1		;  
		RETURN

;***********************************************************************
; WR PULSE
;***********************************************************************
WR_PULSE
		BCF		PORTC,4		; WR Enable
		NOP					; wait
		NOP					; wait
		BSF		PORTC,4		; WR Disable
		NOP					; wait
		NOP					; wait
		RETURN

;***********************************************************************
; 8255AhX
; A3=1 A2=0 Select 8255
; A1  A0
;  0   0  port A
;  0   1  port B
;  1   0  port C
;  1   1  Control
;***********************************************************************
; Set Address 8255 PortA
SA8255PA
		MOVLW	0D8H			; RC7=1 RC6=1 IOREQ=0 WR=1
								; A3=1 A2=0	Adress 8255
								; A1=0 A0=0	8255 PortA							
		MOVWF	PORTC			;
		RETURN

; Set Address 8255 PortB
SA8255PB
		MOVLW	0D9H			; RC7=1 RC6=1 IOREQ=0 WR=1
								; A3=1 A2=0	Adress 8255
								; A1=0 A0=1	8255 PortB							
		MOVWF	PORTC			;
		RETURN

; Set Address 8255 PortC
SA8255PC
		MOVLW	0DAH			; RC7=1 RC6=1 IOREQ=0 WR=1
								; A3=1 A2=0	Adress 8255
								; A1=1 A0=0	8255 PortC							
		MOVWF	PORTC			;
		RETURN

; Set Address 8255 Control
SA8255CTRL
		MOVLW	0DBH			; RC7=1 RC6=1 IOREQ=0 WR=1
								; A3=1 A2=0	Adress 8255
								; A1=1 A0=1	8255 Control							
		MOVWF	PORTC			;
		RETURN

;***********************************************************************
; fBC
;***********************************************************************
;50usDelay(10MHz)
DL50US
		MOVLW	041H		; 1cycle 41H=65
		MOVWF	COUNT0		; 1cycle
LOOP
		DECFSZ	COUNT0,F	; 1~(65-1){2 = 66cycle
		GOTO	LOOP		; 2~(65-1) = 128cycle
		RETURN				; 2 cycle


;5msDealy(10MHz)
DL5MS
		MOVLW	63H			; 1cycle 63H=99
		MOVWF	COUNT1		; 1cycle
LOOP1
		CALL	DL50US		; i2{198j~9919800cycle
		DECFSZ	COUNT1,F	; 1~(99-1){2 = 100cycle
		GOTO	LOOP1		; 2~(99-1) = 196cycle
		RETURN				; 2cycle

;***********************************************************************
; EEPROM DATA
;***********************************************************************

ORG	02100H
DE D'242',D'229',D'216',D'204',D'192',D'181',D'171',D'161'
DE D'152',D'144',D'136',D'128',D'121',D'114',D'108',D'102'
DE D'96', D'90', D'85', D'80', D'76', D'72', D'68', D'64'
DE D'60', D'57', D'54', D'51', D'48', D'45', D'42', D'40'
DE D'38', D'36', D'34', D'32', D'30', D'28', D'27', D'25'
DE D'24', D'22', D'21', D'20', D'19', D'18', D'17', D'16'
DE D'15', D'14', D'13', D'12', D'12', D'11', D'10', D'10'
DE D'9',  D'9',  D'8',  D'8',  D'7',  D'7',  D'6',  D'6'
DE D'6',  D'5',  D'5',  D'5',  D'4',  D'4',  D'4',  D'4'
DE D'3',  D'3',  D'3',  D'3',  D'3',  D'2',  D'2',  D'2'
DE D'2',  D'2',  D'2',  D'2',  D'1',  D'1',  D'1',  D'1'
DE D'1',  D'1',  D'1',  D'1',  D'1',  D'1',  D'1',  D'1'
DE D'0',  D'0',  D'0',  D'0',  D'178',D'19', D'56', D'21'
DE D'161',D'209',D'157',D'251',D'227',D'79', D'53', D'144'
DE D'89', D'137',D'28', D'10', D'80', D'232',D'206',D'253'
DE D'113',D'39', D'26', D'72', D'172',D'68', D'14', D'5'
DE D'40', D'116',D'231',D'126',D'56', D'19', D'13', D'36'
DE D'86', D'162',D'7',  D'130',D'20', D'186',D'115',D'63'
DE D'28', D'9',  D'6',  D'18', D'43', D'81', D'131',D'193'
DE D'10', D'93', D'185',D'31', D'142',D'4',  D'131',D'9'
DE D'149',D'40', D'193',D'96', D'5',  D'174',D'92', D'15'
DE D'199',D'130',D'65', D'4',  D'202',D'148',D'96', D'48'
DE D'2',  D'215',D'174',D'135',D'99', D'65', D'32', D'2'
DE D'229',D'202',D'176',D'152',D'129',D'107',D'87', D'67'
DE D'49', D'32', D'16', D'1',  D'242',D'229',D'216',D'204'

END
